
/* A Bison parser, made by GNU Bison 2.5.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2009 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

#include "calc_parser.hpp"

/* First part of user declarations.  */

/* Line 29 of bison-calc.m4  */
#line 4 "../../../../v3c/flexx/tests/calc.ypp"

// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include <string>
#include <map>
#include <fstream>
#include <sstream>
#include <stdexcept>
#include "calc_scanner.hpp"


/* Line 29 of bison-calc.m4  */
#line 54 "calc_parser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

/* yylloc_default -- Set cur to span from rhs[1] to rhs[n].
   If n is 0, then set cur to the empty location which ends
   the previous symbol: rhs[0] (always defined).  */

#ifndef yylloc_default_defined
#define yylloc_default_defined
template< typename S, typename T >
void yylloc_default(S & cur, const T & rhs, unsigned int n)
{
	if(!cur)
		return;
	if(n) {
		cur->begin = rhs[1]->begin;
		cur->end   = rhs[n]->end;
	}else{
		cur->begin = cur->end = rhs[0]->end;
	}
}
#endif /*#ifndef yylloc_default_defined*/

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

# ifndef YY_SYMBOL_PRINT
#   define YY_SYMBOL_PRINT(Title, Value) \
do { \
	if(yydebug_) \
		*yycdebug_ << Title << ' ' << Value << endl; \
} while (false)
# endif

# define YY_REDUCE_PRINT(Rule) \
do { \
	if(yydebug_) \
		yy_reduce_print_(Rule); \
} while (false)

# define YY_STACK_PRINT() \
do { \
	if (yydebug_) \
		yystack_print_ (); \
} while (false)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

namespace calc {

/* Return YYSTR after stripping away unnecessary quotes and
	backslashes, so that it's suitable for yyerror.  The heuristic is
	that double-quoting is unnecessary unless the string contains an
	apostrophe, a comma, or backslash (other than backslash-backslash).
	YYSTR is taken from yytname.  */
std::string
Parser::yytnamerr_ (const char *yystr)
{
	if (*yystr == '"') {
		std::string yyr = "";
		char const *yyp = yystr;

		for (;;)
			switch (*++yyp) {
			case '\'':
			case ',':
				goto do_not_strip_quotes;
	
			case '\\':
				if (*++yyp != '\\')
				goto do_not_strip_quotes;
				/* Fall through.  */
			default:
				yyr += *yyp;
				break;
	
			case '"':
				return yyr;
			}
		do_not_strip_quotes: ;
	}

	return yystr;
}

/// Build a parser object.
Parser::Parser ()
: ParserTokens()
, yylval()
, m_scanner()
, yystate_stack_()
, yysemantic_stack_()
, yydebug_(false)
, yycdebug_(&std::cerr)

{
}

Parser::~Parser ()
{
}

void
Parser::yypop_ (unsigned int n)
{
	yystate_stack_.pop (n);
	yysemantic_stack_.pop (n);
}

std::ostream&
Parser::debug_stream () const
{
	return *yycdebug_;
}

void
Parser::set_debug_stream (std::ostream& o)
{
	yycdebug_ = &o;
}

bool
Parser::lex_debug() const
{
	return m_scanner.debug();
}
bool
Parser::parse_debug() const
{
	return yydebug_;
}

void
Parser::set_lex_debug(bool b)
{
	m_scanner.set_debug(b);
}
void
Parser::set_parse_debug(bool b)
{
	yydebug_ = b;
}

void
Parser::switch_streams(istream * in, ostream * out)
{
	m_scanner.switch_streams(in, out);
}
int
Parser::parse ()
{
	/// Look-ahead and look-ahead in internal form.
	int yychar = yyempty_;
	int yytoken = 0;

	/* State.  */
	int yyn;
	int yylen = 0;
	int yystate = 0;

	// Error handling.
	yynerrs_ = yyerrstatus_ = 0;

	/// The locations where the error started and ended.
	Span yyerror_range_instances[2];
	Span *yyerror_range[2] = { yyerror_range_instances, yyerror_range_instances+1};;

	/// $$.
	TokenPtr yyval;

	int yyresult;

	YYCDEBUG << "Starting parse" << std::endl;


  /* Initialize the stacks.  The initial state will be pushed in
		yynewstate, since the latter expects the semantical and the
		location values to have been already stored, initialize these
		stacks with a primary value.  */
	yystate_stack_ = state_stack_type(0);
	yysemantic_stack_ = semantic_stack_type(0);
	yysemantic_stack_.push(yylval);

	/* New state.  */
yynewstate:
	yystate_stack_.push (yystate);
	YYCDEBUG << "Entering state " << yystate << std::endl;
	goto yybackup;

	/* Backup.  */
yybackup:

	/* Try to take a decision without look-ahead.  */
	yyn = yypact_[yystate];
	if (yyn == yypact_ninf_)
		goto yydefault;

    /* Read a look-ahead token.  */
	if (yychar == yyempty_) {
		YYCDEBUG << "Reading a token: ";
		try {
			yylval = m_scanner.read ();
			yychar = yylval->id();
		} catch(const TokenPtr & e) { // Nested return.
			yylval = e;
			yychar = yylval->id();
		} catch(const v3c::scanner_result & e) {
			yychar = e.result;
			yylval = 0; // Shouldn't do this.
		}
	}


	/* Convert token to internal form.  */
	if (yychar <= yyeof_) {
		yychar = yytoken = yyeof_;
		YYCDEBUG << "Now at end of input." << std::endl;
	}else{
		yytoken = yytranslate_ (yychar);
		YY_SYMBOL_PRINT("Next token is", yylval);
	}

	/* If the proper action on seeing token YYTOKEN is to reduce or to
		detect an error, take that action.  */
	yyn += yytoken;
	if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
		goto yydefault;

	/* Reduce or error.  */
	yyn = yytable_[yyn];
	if (yyn <= 0) {
		if (yyn == 0 || yyn == yytable_ninf_)
			goto yyerrlab;
		yyn = -yyn;
		goto yyreduce;
	}

	/* Accept?  */
	if (yyn == yyfinal_)
		goto yyacceptlab;

	/* Shift the look-ahead token.  */
	YY_SYMBOL_PRINT("Shifting", yylval);

	/* Discard the token being shifted unless it is eof.  */
	if (yychar != yyeof_)
		yychar = yyempty_;

	yysemantic_stack_.push (yylval);

	/* Count tokens shifted since error; after three, turn off error
		status.  */
	if (yyerrstatus_)
		--yyerrstatus_;

	yystate = yyn;
	goto yynewstate;

	/*-----------------------------------------------------------.
	| yydefault -- do the default action for the current state.  |
	`-----------------------------------------------------------*/
yydefault:
	yyn = yydefact_[yystate];
	if (yyn == 0)
		goto yyerrlab;
	goto yyreduce;

	/*-----------------------------.
	| yyreduce -- Do a reduction.  |
	`-----------------------------*/
yyreduce:
	yylen = yyr2_[yyn];
	/* If YYLEN is nonzero, implement the default value of the action:
		`$$ = $1'.  Otherwise, use the top of the stack.

		Otherwise, the following line sets YYVAL to garbage.
		This behavior is undocumented and Bison
		users should not rely upon it.  */
	if (yylen)
		yyval = yysemantic_stack_[yylen - 1];
	else
		yyval = yysemantic_stack_[0];

	{
		slice<TokenPtr, semantic_stack_type> slice(yysemantic_stack_, yylen);
		if(yylen)
			yylloc_default(yyval, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 2:

/* Line 29 of bison-calc.m4  */
#line 23 "../../../../v3c/flexx/tests/calc.ypp"
    { store_result((yysemantic_stack_[(2) - (2)])); }
    break;

  case 3:

/* Line 29 of bison-calc.m4  */
#line 25 "../../../../v3c/flexx/tests/calc.ypp"
    {}
    break;

  case 4:

/* Line 29 of bison-calc.m4  */
#line 26 "../../../../v3c/flexx/tests/calc.ypp"
    {}
    break;

  case 5:

/* Line 29 of bison-calc.m4  */
#line 28 "../../../../v3c/flexx/tests/calc.ypp"
    { assign((yysemantic_stack_[(3) - (1)]), (yysemantic_stack_[(3) - (3)])); }
    break;

  case 6:

/* Line 29 of bison-calc.m4  */
#line 32 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = add ((yysemantic_stack_[(3) - (1)]), (yysemantic_stack_[(3) - (3)])); }
    break;

  case 7:

/* Line 29 of bison-calc.m4  */
#line 33 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = sub ((yysemantic_stack_[(3) - (1)]), (yysemantic_stack_[(3) - (3)])); }
    break;

  case 8:

/* Line 29 of bison-calc.m4  */
#line 34 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = mult((yysemantic_stack_[(3) - (1)]), (yysemantic_stack_[(3) - (3)])); }
    break;

  case 9:

/* Line 29 of bison-calc.m4  */
#line 35 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = div ((yysemantic_stack_[(3) - (1)]), (yysemantic_stack_[(3) - (3)])); }
    break;

  case 10:

/* Line 29 of bison-calc.m4  */
#line 36 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = fetch((yysemantic_stack_[(1) - (1)])); }
    break;

  case 11:

/* Line 29 of bison-calc.m4  */
#line 37 "../../../../v3c/flexx/tests/calc.ypp"
    { (yyval) = (yysemantic_stack_[(1) - (1)]); }
    break;



/* Line 29 of bison-calc.m4  */
#line 454 "calc_parser.cpp"
	default: break;
      }
	YY_SYMBOL_PRINT("-> $$ =", yyval);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push(yyval);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

	/*------------------------------------.
	| yyerrlab -- here on detecting error |
	`------------------------------------*/
yyerrlab:
	/* If not already recovering from an error, report this error.  */
	if (!yyerrstatus_) {
		++yynerrs_;
		error(yylval ? * yylval : Span(m_scanner, m_scanner)
			, yysyntax_error_(yystate, yytoken));
      }

	*yyerror_range[0] = *yylval;
	if (yyerrstatus_ == 3) {
		/* If just tried and failed to reuse look-ahead token after an
		 error, discard it.  */

		if (yychar <= yyeof_) {
			/* Return failure if at end of input.  */
			if (yychar == yyeof_)
				YYABORT;
		}else{
			YY_SYMBOL_PRINT("Error: discarding", yylval);
			yychar = yyempty_;
		}
	}

	/* Else will try to reuse look-ahead token after shifting the error
		token.  */
	goto yyerrlab1;

	/*---------------------------------------------------.
	| yyerrorlab -- error raised explicitly by YYERROR.  |
	`---------------------------------------------------*/
yyerrorlab:

	/* Pacify compilers like GCC when the user code never invokes
		YYERROR and the label yyerrorlab therefore never appears in user
		code.  */
	if (false)
		goto yyerrorlab;

	*yyerror_range[0] = *yysemantic_stack_[yylen - 1];
	/* Do not reclaim the symbols of the rule which action triggered
		this YYERROR.  */
	yypop_ (yylen);
	yylen = 0;
	yystate = yystate_stack_[0];
	goto yyerrlab1;

	/*-------------------------------------------------------------.
	| yyerrlab1 -- common code for both syntax error and YYERROR.  |
	`-------------------------------------------------------------*/
yyerrlab1:
	yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

	for(;;) {
		yyn = yypact_[yystate];
		if(yyn != yypact_ninf_) {
			yyn += yyterror_;
			if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_) {
				yyn = yytable_[yyn];
				if (0 < yyn)
				break;
			}
		}

		/* Pop the current state because it cannot handle the error token.  */
		if(yystate_stack_.size() == 1)
			YYABORT;

		*yyerror_range[0] = *yysemantic_stack_[0];
		YY_SYMBOL_PRINT("Error: popping", yysemantic_stack_[0]);
		yypop_();
		yystate = yystate_stack_[0];
		YY_STACK_PRINT();
	}

	if (yyn == yyfinal_)
		goto yyacceptlab;

	*yyerror_range[1] = *yylval;
	// Using YYLLOC is tempting, but would change the location of
	// the look-ahead.  YYLOC is available though.
	yylloc_default(yyval, (yyerror_range - 1), 2);
	yysemantic_stack_.push (yylval);

	/* Shift the error token.  */
	YY_SYMBOL_PRINT ("Shifting", yysemantic_stack_[0]);

	yystate = yyn;
	goto yynewstate;

	/* Accept.  */
yyacceptlab:
	yyresult = 0;
	goto yyreturn;

	/* Abort.  */
yyabortlab:
	yyresult = 1;
	goto yyreturn;

yyreturn:
	if (yychar != yyeof_ && yychar != yyempty_)
		YY_SYMBOL_PRINT("Cleanup: discarding lookahead", yylval);

	/* Do not reclaim the symbols of the rule which action triggered
		this YYABORT or YYACCEPT.  */
	yypop_ (yylen);
	while (yystate_stack_.size() != 1) {
		YY_SYMBOL_PRINT("Cleanup: popping", yysemantic_stack_[0]);
		yypop_ ();
	}

	return yyresult;
}

// Generate an error message.
std::string
Parser::yysyntax_error_ (int yystate, int tok)
{
	std::string res;
	YYUSE (yystate);
#if YYERROR_VERBOSE
	int yyn = yypact_[yystate];
	if (yypact_ninf_ < yyn && yyn <= yylast_) {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
		if (yycheck_[x + yyn] == x && x != yyterror_)
			++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char Parser::yypact_ninf_ = -9;
  const signed char
  Parser::yypact_[] =
  {
        -9,    15,     6,    -9,    12,    -9,    -9,    -1,     7,     7,
       7,     7,     7,    -9,    -1,     5,     5,    -9,    -9
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  Parser::yydefact_[] =
  {
         4,     0,     0,     1,    10,    11,     3,     2,     0,     0,
       0,     0,     0,    10,     5,     6,     7,     8,     9
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  Parser::yypgoto_[] =
  {
        -9,    -9,    -9,    -9,    -8
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  Parser::yydefgoto_[] =
  {
        -1,     1,     2,     6,     7
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char Parser::yytable_ninf_ = -1;
  const unsigned char
  Parser::yytable_[] =
  {
        14,    15,    16,    17,    18,     9,    10,    11,    12,     4,
      13,     5,     5,    11,    12,     3,     8
  };

  /* YYCHECK.  */
  const unsigned char
  Parser::yycheck_[] =
  {
         8,     9,    10,    11,    12,     6,     7,     8,     9,     3,
       3,     5,     5,     8,     9,     0,     4
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  Parser::yystos_[] =
  {
         0,    11,    12,     0,     3,     5,    13,    14,     4,     6,
       7,     8,     9,     3,    14,    14,    14,    14,    14
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  Parser::yytoken_number_[] =
  {
         0,   256,   303,   300,   301,   302,    43,    45,    42,    47
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  Parser::yyr1_[] =
  {
         0,    10,    11,    12,    12,    13,    14,    14,    14,    14,
      14,    14
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  Parser::yyr2_[] =
  {
         0,     2,     2,     2,     0,     3,     3,     3,     3,     3,
       1,     1
  };

  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const Parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "\"identifier\"", "\":=\"",
  "\"number\"", "'+'", "'-'", "'*'", "'/'", "$accept", "unit",
  "assignments", "assignment", "exp", 0
  };

  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const Parser::rhs_number_type
  Parser::yyrhs_[] =
  {
        11,     0,    -1,    12,    14,    -1,    12,    13,    -1,    -1,
       3,     4,    14,    -1,    14,     6,    14,    -1,    14,     7,
      14,    -1,    14,     8,    14,    -1,    14,     9,    14,    -1,
       3,    -1,     5,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned char
  Parser::yyprhs_[] =
  {
         0,     0,     3,     6,     9,    10,    14,    18,    22,    26,
      30,    32
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned char
  Parser::yyrline_[] =
  {
         0,    23,    23,    25,    26,    28,    32,    33,    34,    35,
      36,    37
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "), \n";
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT("   $" << yyi + 1 << " =",
		       (yysemantic_stack_[(yynrhs) - (yyi + 1)]));
  }

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  Parser::token_number_type
  Parser::yytranslate_ (int t) const
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     8,     6,     2,     7,     2,     9,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     4,     5,     2
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int Parser::yyeof_ = 0;
  const int Parser::yylast_ = 16;
  const int Parser::yynnts_ = 5;
  const int Parser::yyempty_ = -2;
  const int Parser::yyfinal_ = 3;
  const int Parser::yyterror_ = 1;
  const int Parser::yyerrcode_ = 256;
  const int Parser::yyntokens_ = 10;

  const unsigned int Parser::yyuser_token_number_max_ = 303;
  const Parser::token_number_type Parser::yyundef_token_ = 2;

} // namespace calc



/* Line 29 of bison-calc.m4  */
#line 38 "../../../../v3c/flexx/tests/calc.ypp"


