%{
// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include "flexx.hpp"
class Scanner : public v3c::Flexx
{
	FLEXX_IMPL(int);
public:
	enum { eTerminateValue };
};
Scanner * pScanner = 0;
%}

%option outfile="simple.cpp"
%option nounput batch
%option c++ 8bit warn noyywrap nodefault debug
%option yyclass="Scanner"
%option stack
%option stdinit
%option yylineno
/*%option yywrap
*/
%x A B
%%
<A>mega-		ECHO; yymore();
<A,B>\n			;
kludge			ECHO; REJECT;
<A,B,INITIAL>.	ECHO;
\n       		ECHO; yyless(3);
%%
int main(int argc, char * argv[])
{
	(void)argc;
	(void)argv;
	Scanner scanner;
	return 0;
}
