// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.
#include <iostream>
#include "calc++-driver.hh"

int
main(int argc, char *argv[])
{
	calcxx_driver driver;
	for (--argc, ++argv; argc; ++argv, --argc)
		if (*argv == std::string ("-p"))
			driver.trace_parsing = true;
		else if (*argv == std::string ("-s"))
			driver.trace_scanning = true;
		else{
			driver.parse(*argv);
			std::cout << driver.result << std::endl;
			break;
		}
	return 0;
}
