#if !defined(v3c_cmdline_scanner_hpp_included)
#define v3c_cmdline_scanner_hpp_included

// Copyright (C) 2009  Philip Ashmore (contact@philipashmore.com)
// License: LGPLv3.  See LICENSE.txt for the full license.

#include <v3c/flexx/flexx.hpp>
#include "v3c_cmdline_parser_tokens.hpp"


namespace v3c
{
namespace cmdline
{

using namespace std;

class Parser;

struct Option
{
	enum Arg{eNone, eRequired, eOptional};
	const char *name;
	Arg arg;
	int val;
};

class Scanner: public Flexx, public ParserTokens
{
	FLEXX_IMPL(FlexxTokenPtr);
protected:
	FlexxTokenPtr make_token(int t);
};

} // namespace cmdline
} // namespace v3c

#endif // #if !defined(v3c_cmdline_scanner_hpp_included)
