
/* A Bison parser, made by GNU Bison 2.5.  */

/* Skeleton implementation for Bison LALR(1) parsers in C++
   
      Copyright (C) 2009 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

#include "bisonx_parser.hpp"

/* First part of user declarations.  */

/* Line 81 of bison-parse.m4  */
#line 4 "../../../v3c/parse/bisonx_parser.ypp"

#include <v3c/trace_scope.hpp>
#include <string>
#include <cstring>
#include <map>
#include <fstream>
#include <sstream>
#include <stdexcept>
#include "bisonx_scanner.hpp"
#include "bisonx_grammar.hpp"
#include <v3c/cmdline/scanner.hpp>

using namespace v3c;
using namespace std;


/* Line 81 of bison-parse.m4  */
#line 58 "bisonx_parser.cpp"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

/* yylloc_default -- Set cur to span from rhs[1] to rhs[n].
   If n is 0, then set cur to the empty location which ends
   the previous symbol: rhs[0] (always defined).  */

#ifndef yylloc_default_defined
#define yylloc_default_defined
template< typename S, typename T >
void yylloc_default(S & cur, const T & rhs, unsigned int n)
{
	if(!cur)
		return;
	if(n) {
		cur->begin = rhs[1]->begin;
		cur->end   = rhs[n]->end;
	}else{
		cur->begin = cur->end = rhs[0]->end;
	}
}
#endif /*#ifndef yylloc_default_defined*/

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* FIXME: INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#define YYUSE(e) ((void) (e))

/* A pseudo ostream that takes yydebug_ into account.  */
# define YYCDEBUG							\
  for (bool yydebugcond_ = yydebug_; yydebugcond_; yydebugcond_ = false)	\
    (*yycdebug_)

# ifndef YY_SYMBOL_PRINT
#   define YY_SYMBOL_PRINT(Title, Value) \
do { \
	if(yydebug_) \
		*yycdebug_ << Title << ' ' << Value << endl; \
} while (false)
# endif

# define YY_REDUCE_PRINT(Rule) \
do { \
	if(yydebug_) \
		yy_reduce_print_(Rule); \
} while (false)

# define YY_STACK_PRINT() \
do { \
	if (yydebug_) \
		yystack_print_ (); \
} while (false)

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab

namespace v3c {
namespace bisonx {
namespace impl {

/* Return YYSTR after stripping away unnecessary quotes and
	backslashes, so that it's suitable for yyerror.  The heuristic is
	that double-quoting is unnecessary unless the string contains an
	apostrophe, a comma, or backslash (other than backslash-backslash).
	YYSTR is taken from yytname.  */
std::string
Parser::yytnamerr_ (const char *yystr)
{
	if (*yystr == '"') {
		std::string yyr = "";
		char const *yyp = yystr;

		for (;;)
			switch (*++yyp) {
			case '\'':
			case ',':
				goto do_not_strip_quotes;
	
			case '\\':
				if (*++yyp != '\\')
				goto do_not_strip_quotes;
				/* Fall through.  */
			default:
				yyr += *yyp;
				break;
	
			case '"':
				return yyr;
			}
		do_not_strip_quotes: ;
	}

	return yystr;
}

/// Build a parser object.
Parser::Parser ()
: ParserTokens()
, yylval()
, m_scanner(*this)
, yystate_stack_()
, yysemantic_stack_()
, yydebug_(false)
, yycdebug_(&std::cerr)

, grammar(0)
, expected_sr_conflicts(-1)
, expected_rr_conflicts(-1)
, spec_name_prefix()
, spec_file_prefix()

, current_class(unknown_sym)
, current_rule(0)
, current_prec(0)

, debug_flag()
, defines_flag()
, graph_flag()
, no_lines_flag()
, error_verbose(false)
, report_flag(report_none)
, trace_flag(trace_none)
, spec_outfile()
{
}

Parser::~Parser ()
{
}

void
Parser::yypop_ (unsigned int n)
{
	yystate_stack_.pop (n);
	yysemantic_stack_.pop (n);
}

std::ostream&
Parser::debug_stream () const
{
	return *yycdebug_;
}

void
Parser::set_debug_stream (std::ostream& o)
{
	yycdebug_ = &o;
}

bool
Parser::lex_debug() const
{
	return m_scanner.debug();
}
bool
Parser::parse_debug() const
{
	return yydebug_;
}

void
Parser::set_lex_debug(bool b)
{
	m_scanner.set_debug(b);
}
void
Parser::set_parse_debug(bool b)
{
	yydebug_ = b;
}

void
Parser::switch_streams(istream * in, ostream * out)
{
	m_scanner.switch_streams(in, out);
}
int
Parser::parse ()
{
	/// Look-ahead and look-ahead in internal form.
	int yychar = yyempty_;
	int yytoken = 0;

	/* State.  */
	int yyn;
	int yylen = 0;
	int yystate = 0;

	// Error handling.
	yynerrs_ = yyerrstatus_ = 0;

	/// The locations where the error started and ended.
	Span yyerror_range_instances[2];
	Span *yyerror_range[2] = { yyerror_range_instances, yyerror_range_instances+1};;

	/// $$.
	NodePtr yyval;

	int yyresult;

	YYCDEBUG << "Starting parse" << std::endl;


  /* Initialize the stacks.  The initial state will be pushed in
		yynewstate, since the latter expects the semantical and the
		location values to have been already stored, initialize these
		stacks with a primary value.  */
	yystate_stack_ = state_stack_type(0);
	yysemantic_stack_ = semantic_stack_type(0);
	yysemantic_stack_.push(yylval);

	/* New state.  */
yynewstate:
	yystate_stack_.push (yystate);
	YYCDEBUG << "Entering state " << yystate << std::endl;
	goto yybackup;

	/* Backup.  */
yybackup:

	/* Try to take a decision without look-ahead.  */
	yyn = yypact_[yystate];
	if (yyn == yypact_ninf_)
		goto yydefault;

    /* Read a look-ahead token.  */
	if (yychar == yyempty_) {
		YYCDEBUG << "Reading a token: ";
		try {
			yylval = m_scanner.read ();
			yychar = yylval->id();
		} catch(const NodePtr & e) { // Nested return.
			yylval = e;
			yychar = yylval->id();
		} catch(const v3c::scanner_result & e) {
			yychar = e.result;
			yylval = 0; // Shouldn't do this.
		}
	}


	/* Convert token to internal form.  */
	if (yychar <= yyeof_) {
		yychar = yytoken = yyeof_;
		YYCDEBUG << "Now at end of input." << std::endl;
	}else{
		yytoken = yytranslate_ (yychar);
		YY_SYMBOL_PRINT("Next token is", yylval);
	}

	/* If the proper action on seeing token YYTOKEN is to reduce or to
		detect an error, take that action.  */
	yyn += yytoken;
	if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yytoken)
		goto yydefault;

	/* Reduce or error.  */
	yyn = yytable_[yyn];
	if (yyn <= 0) {
		if (yyn == 0 || yyn == yytable_ninf_)
			goto yyerrlab;
		yyn = -yyn;
		goto yyreduce;
	}

	/* Accept?  */
	if (yyn == yyfinal_)
		goto yyacceptlab;

	/* Shift the look-ahead token.  */
	YY_SYMBOL_PRINT("Shifting", yylval);

	/* Discard the token being shifted unless it is eof.  */
	if (yychar != yyeof_)
		yychar = yyempty_;

	yysemantic_stack_.push (yylval);

	/* Count tokens shifted since error; after three, turn off error
		status.  */
	if (yyerrstatus_)
		--yyerrstatus_;

	yystate = yyn;
	goto yynewstate;

	/*-----------------------------------------------------------.
	| yydefault -- do the default action for the current state.  |
	`-----------------------------------------------------------*/
yydefault:
	yyn = yydefact_[yystate];
	if (yyn == 0)
		goto yyerrlab;
	goto yyreduce;

	/*-----------------------------.
	| yyreduce -- Do a reduction.  |
	`-----------------------------*/
yyreduce:
	yylen = yyr2_[yyn];
	/* If YYLEN is nonzero, implement the default value of the action:
		`$$ = $1'.  Otherwise, use the top of the stack.

		Otherwise, the following line sets YYVAL to garbage.
		This behavior is undocumented and Bison
		users should not rely upon it.  */
	if (yylen)
		yyval = yysemantic_stack_[yylen - 1];
	else
		yyval = yysemantic_stack_[0];

	{
		slice<NodePtr, semantic_stack_type> slice(yysemantic_stack_, yylen);
		if(yylen)
			yylloc_default(yyval, slice, yylen);
    }
    YY_REDUCE_PRINT (yyn);
    switch (yyn)
      {
	  case 6:

/* Line 81 of bison-parse.m4  */
#line 107 "../../../v3c/parse/bisonx_parser.ypp"
    {
		if(grammar->prologue) {
			stringstream ss;
			ss << "The prologue section found at "
				<< static_cast< Span & >( * (yysemantic_stack_[(1) - (1)]) )
				<< " conflicts with the one at previously declared at "
				<< static_cast< Span & >( * grammar->prologue )
				<< ".\nAs there is no %union directive, this is disallowed.";
			throw runtime_error(ss.str());
		}
		grammar->prologue = *(StringTokenPtr*)(&(yysemantic_stack_[(1) - (1)])); // Smart pointer cast(!)
	}
    break;

  case 7:

/* Line 81 of bison-parse.m4  */
#line 119 "../../../v3c/parse/bisonx_parser.ypp"
    { debug_flag = true; }
    break;

  case 8:

/* Line 81 of bison-parse.m4  */
#line 121 "../../../v3c/parse/bisonx_parser.ypp"
    {
		static string one = "1";
		grammar->defines[(yysemantic_stack_[(2) - (2)])->string_value()] = one;
	}
    break;

  case 9:

/* Line 81 of bison-parse.m4  */
#line 126 "../../../v3c/parse/bisonx_parser.ypp"
    {
		NodePtr pkey = (yysemantic_stack_[(3) - (2)]);
		NodePtr pvalue = (yysemantic_stack_[(3) - (3)]);
		string key = pkey->string_value();
		string value = pvalue->string_value();
		grammar->defines[key] = value;
	}
    break;

  case 10:

/* Line 81 of bison-parse.m4  */
#line 133 "../../../v3c/parse/bisonx_parser.ypp"
    { defines_flag = true; }
    break;

  case 11:

/* Line 81 of bison-parse.m4  */
#line 134 "../../../v3c/parse/bisonx_parser.ypp"
    { error_verbose = true; }
    break;

  case 12:

/* Line 81 of bison-parse.m4  */
#line 135 "../../../v3c/parse/bisonx_parser.ypp"
    { expected_sr_conflicts = (yysemantic_stack_[(2) - (2)]); }
    break;

  case 13:

/* Line 81 of bison-parse.m4  */
#line 136 "../../../v3c/parse/bisonx_parser.ypp"
    { expected_rr_conflicts = (yysemantic_stack_[(2) - (2)]); }
    break;

  case 14:

/* Line 81 of bison-parse.m4  */
#line 137 "../../../v3c/parse/bisonx_parser.ypp"
    { spec_file_prefix = (yysemantic_stack_[(3) - (3)]); }
    break;

  case 15:

/* Line 81 of bison-parse.m4  */
#line 139 "../../../v3c/parse/bisonx_parser.ypp"
    {
      grammar->initial_actions.push_back(*(CodeTokenPtr*)(&(yysemantic_stack_[(1) - (1)])));
    }
    break;

  case 16:

/* Line 81 of bison-parse.m4  */
#line 142 "../../../v3c/parse/bisonx_parser.ypp"
    { spec_name_prefix = (yysemantic_stack_[(3) - (3)]); }
    break;

  case 17:

/* Line 81 of bison-parse.m4  */
#line 143 "../../../v3c/parse/bisonx_parser.ypp"
    { no_lines_flag = true; }
    break;

  case 18:

/* Line 81 of bison-parse.m4  */
#line 144 "../../../v3c/parse/bisonx_parser.ypp"
    { spec_outfile = (yysemantic_stack_[(3) - (3)]); }
    break;

  case 19:

/* Line 81 of bison-parse.m4  */
#line 145 "../../../v3c/parse/bisonx_parser.ypp"
    { version_check((yysemantic_stack_[(2) - (2)])); }
    break;

  case 20:

/* Line 81 of bison-parse.m4  */
#line 146 "../../../v3c/parse/bisonx_parser.ypp"
    { report_flag = report_states; }
    break;

  case 24:

/* Line 81 of bison-parse.m4  */
#line 154 "../../../v3c/parse/bisonx_parser.ypp"
    {
      grammar->start_symbol = (yysemantic_stack_[(2) - (2)])->string_value();
    }
    break;

  case 25:

/* Line 81 of bison-parse.m4  */
#line 158 "../../../v3c/parse/bisonx_parser.ypp"
    {
		(yyval) = NodePtr();
	}
    break;

  case 26:

/* Line 81 of bison-parse.m4  */
#line 162 "../../../v3c/parse/bisonx_parser.ypp"
    {
		(yyval) = NodePtr();
	}
    break;

  case 27:

/* Line 81 of bison-parse.m4  */
#line 166 "../../../v3c/parse/bisonx_parser.ypp"
    {
		(yyval) = NodePtr();
	}
    break;

  case 28:

/* Line 81 of bison-parse.m4  */
#line 170 "../../../v3c/parse/bisonx_parser.ypp"
    {
      grammar->default_prec = true;
    }
    break;

  case 29:

/* Line 81 of bison-parse.m4  */
#line 174 "../../../v3c/parse/bisonx_parser.ypp"
    {
      grammar->default_prec = false;
    }
    break;

  case 30:

/* Line 81 of bison-parse.m4  */
#line 180 "../../../v3c/parse/bisonx_parser.ypp"
    { current_class = nterm_sym; }
    break;

  case 31:

/* Line 81 of bison-parse.m4  */
#line 181 "../../../v3c/parse/bisonx_parser.ypp"
    {
      current_class = unknown_sym;
    }
    break;

  case 32:

/* Line 81 of bison-parse.m4  */
#line 184 "../../../v3c/parse/bisonx_parser.ypp"
    { current_class = token_sym; }
    break;

  case 33:

/* Line 81 of bison-parse.m4  */
#line 185 "../../../v3c/parse/bisonx_parser.ypp"
    {
      current_class = unknown_sym;
   }
    break;

  case 34:

/* Line 81 of bison-parse.m4  */
#line 191 "../../../v3c/parse/bisonx_parser.ypp"
    {
		++current_prec;
		Assoc a = (Assoc)((yysemantic_stack_[(2) - (1)])->int_value());
		switch((yysemantic_stack_[(2) - (2)])->type()) {
		/*case Node::eRule: { // A production
			Rule & rule = $2->asRule();
			Production & p = rule.productions.back();
			p.prec_set(current_prec);
			p.assoc_set(a);
			break; }
		*/case Node::eString: { // A (string) token
			Token * p = new Token((yysemantic_stack_[(2) - (2)]));
			p->prec_set(current_prec);
			p->assoc_set(a);
			grammar->symbols[p->name()] = p;
			break; }
		case Node::eTokenList: { // A list of tokens
			TokenList & t = (yysemantic_stack_[(2) - (2)])->asTokenList();
			t.prec_set(current_prec);
			t.assoc_set(a);
			SymbolPtrVec::iterator i = t.tokens.begin();
			SymbolPtrVec::iterator j = t.tokens.end();
			for(; i != j; ++i) {
				SymbolPtr & p = *i;
				grammar->symbols[p->name()] = p;
			}
			break; }
		default: {
			stringstream ss;
			ss << (yysemantic_stack_[(2) - (2)]);
			string s = ss.str();
			fatal_at((yysemantic_stack_[(2) - (2)])->asSpan(), "Unexpected value \"%s\"", s.c_str());
			}
		}
	}
    break;

  case 35:

/* Line 81 of bison-parse.m4  */
#line 229 "../../../v3c/parse/bisonx_parser.ypp"
    { (yyval) = new IntToken(Span(), (int)left_assoc, INT); }
    break;

  case 36:

/* Line 81 of bison-parse.m4  */
#line 230 "../../../v3c/parse/bisonx_parser.ypp"
    { (yyval) = new IntToken(Span(), (int)right_assoc, INT); }
    break;

  case 37:

/* Line 81 of bison-parse.m4  */
#line 231 "../../../v3c/parse/bisonx_parser.ypp"
    { (yyval) = new IntToken(Span(), (int)non_assoc, INT); }
    break;

  case 39:

/* Line 81 of bison-parse.m4  */
#line 238 "../../../v3c/parse/bisonx_parser.ypp"
    {
		if((yysemantic_stack_[(2) - (1)])->type() == Node::eTokenList) {
			trace << "Appending \"" << (yysemantic_stack_[(2) - (2)])->string_value() << "\" to token list." << endl;
			(yysemantic_stack_[(2) - (1)])->asTokenList().tokens.push_back(*(SymbolPtr*)(&(yysemantic_stack_[(2) - (2)]))); // Smart pointer cast(!)
		}else{
			trace << "Creating token list from \"" << (yysemantic_stack_[(2) - (1)])->string_value() << "\"." << endl;
			TokenList * p = new TokenList();
			p->tokens.push_back(new Token((yysemantic_stack_[(2) - (1)])));
			p->tokens.push_back(new Token((yysemantic_stack_[(2) - (2)])));
			(yyval) = p;
		}
	}
    break;

  case 40:

/* Line 81 of bison-parse.m4  */
#line 255 "../../../v3c/parse/bisonx_parser.ypp"
    {
		const string & name = (yysemantic_stack_[(1) - (1)])->string_value();
		Token * p = new Token((yysemantic_stack_[(1) - (1)])->asSpan(), name);
		(yyval) = p;
		grammar->symbols[name] = *(SymbolPtr*)(&(yyval)); // Smart pointer cast(!)
	}
    break;

  case 41:

/* Line 81 of bison-parse.m4  */
#line 262 "../../../v3c/parse/bisonx_parser.ypp"
    {
		const string & name = (yysemantic_stack_[(2) - (1)])->string_value();
		Token * p = new Token((yysemantic_stack_[(2) - (1)])->asSpan(), name);
		(yyval) = p;
		p->user_token_number_set((yysemantic_stack_[(2) - (2)])->int_value());
		grammar->symbols[name] = *(SymbolPtr*)(&(yyval)); // Smart pointer cast(!)
	}
    break;

  case 42:

/* Line 81 of bison-parse.m4  */
#line 270 "../../../v3c/parse/bisonx_parser.ypp"
    {
		const string & name = (yysemantic_stack_[(2) - (1)])->string_value();
		Token * p = new Token((yysemantic_stack_[(2) - (1)])->asSpan(), name);
		(yyval) = p;
		grammar->symbols[name] = *(SymbolPtr*)(&(yyval)); // Smart pointer cast(!)
		symbol_make_alias(p, (yysemantic_stack_[(2) - (2)]));
	}
    break;

  case 43:

/* Line 81 of bison-parse.m4  */
#line 278 "../../../v3c/parse/bisonx_parser.ypp"
    {
		Token * p = new Token((yysemantic_stack_[(3) - (1)]));
		(yyval) = p;
		// A smart pointer cast is needed as otherwise we would have two smart
		// pointers referencing the same data, a no-no.
		grammar->symbols[p->name()] = *(SymbolPtr*)(&(yyval));
		p->user_token_number_set((yysemantic_stack_[(3) - (2)])->int_value());
		symbol_make_alias(p, (yysemantic_stack_[(3) - (3)]));
	}
    break;

  case 50:

/* Line 81 of bison-parse.m4  */
#line 311 "../../../v3c/parse/bisonx_parser.ypp"
    {
      yyerrok();
    }
    break;

  case 51:

/* Line 81 of bison-parse.m4  */
#line 316 "../../../v3c/parse/bisonx_parser.ypp"
    {
	const string & name = (yysemantic_stack_[(1) - (1)])->string_value();
	(yyval) = current_rule = new Rule((yysemantic_stack_[(1) - (1)]));
	grammar->symbols[name] = *(SymbolPtr*)(&(yyval)); // Smart pointer cast(!)
	}
    break;

  case 53:

/* Line 81 of bison-parse.m4  */
#line 324 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_end((yysemantic_stack_[(1) - (1)])); }
    break;

  case 54:

/* Line 81 of bison-parse.m4  */
#line 325 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_end((yysemantic_stack_[(3) - (3)])); }
    break;

  case 56:

/* Line 81 of bison-parse.m4  */
#line 331 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_begin(); }
    break;

  case 57:

/* Line 81 of bison-parse.m4  */
#line 333 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_append((yysemantic_stack_[(2) - (2)])); }
    break;

  case 58:

/* Line 81 of bison-parse.m4  */
#line 335 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_append((yysemantic_stack_[(2) - (2)])); }
    break;

  case 59:

/* Line 81 of bison-parse.m4  */
#line 337 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_prec_set((yysemantic_stack_[(3) - (3)])); }
    break;

  case 60:

/* Line 81 of bison-parse.m4  */
#line 339 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_dprec_set((yysemantic_stack_[(3) - (3)])); }
    break;

  case 61:

/* Line 81 of bison-parse.m4  */
#line 341 "../../../v3c/parse/bisonx_parser.ypp"
    { rule_merge_set((yysemantic_stack_[(3) - (3)])); }
    break;

  case 65:

/* Line 81 of bison-parse.m4  */
#line 356 "../../../v3c/parse/bisonx_parser.ypp"
    {
      (yyval) = new SymbolRef((yysemantic_stack_[(1) - (1)]));
    }
    break;

  case 66:

/* Line 81 of bison-parse.m4  */
#line 364 "../../../v3c/parse/bisonx_parser.ypp"
    { (yyval) = (yysemantic_stack_[(1) - (1)]); }
    break;

  case 68:

/* Line 81 of bison-parse.m4  */
#line 371 "../../../v3c/parse/bisonx_parser.ypp"
    {
      grammar->epilogue = *(StringTokenPtr*)(&(yysemantic_stack_[(2) - (2)]));
    }
    break;



/* Line 81 of bison-parse.m4  */
#line 855 "bisonx_parser.cpp"
	default: break;
      }
	YY_SYMBOL_PRINT("-> $$ =", yyval);

    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();

    yysemantic_stack_.push(yyval);

    /* Shift the result of the reduction.  */
    yyn = yyr1_[yyn];
    yystate = yypgoto_[yyn - yyntokens_] + yystate_stack_[0];
    if (0 <= yystate && yystate <= yylast_
	&& yycheck_[yystate] == yystate_stack_[0])
      yystate = yytable_[yystate];
    else
      yystate = yydefgoto_[yyn - yyntokens_];
    goto yynewstate;

	/*------------------------------------.
	| yyerrlab -- here on detecting error |
	`------------------------------------*/
yyerrlab:
	/* If not already recovering from an error, report this error.  */
	if (!yyerrstatus_) {
		++yynerrs_;
		error(yylval ? * yylval : Span(m_scanner, m_scanner)
			, yysyntax_error_(yystate, yytoken));
      }

	*yyerror_range[0] = *yylval;
	if (yyerrstatus_ == 3) {
		/* If just tried and failed to reuse look-ahead token after an
		 error, discard it.  */

		if (yychar <= yyeof_) {
			/* Return failure if at end of input.  */
			if (yychar == yyeof_)
				YYABORT;
		}else{
			YY_SYMBOL_PRINT("Error: discarding", yylval);
			yychar = yyempty_;
		}
	}

	/* Else will try to reuse look-ahead token after shifting the error
		token.  */
	goto yyerrlab1;

	/*---------------------------------------------------.
	| yyerrorlab -- error raised explicitly by YYERROR.  |
	`---------------------------------------------------*/
yyerrorlab:

	/* Pacify compilers like GCC when the user code never invokes
		YYERROR and the label yyerrorlab therefore never appears in user
		code.  */
	if (false)
		goto yyerrorlab;

	*yyerror_range[0] = *yysemantic_stack_[yylen - 1];
	/* Do not reclaim the symbols of the rule which action triggered
		this YYERROR.  */
	yypop_ (yylen);
	yylen = 0;
	yystate = yystate_stack_[0];
	goto yyerrlab1;

	/*-------------------------------------------------------------.
	| yyerrlab1 -- common code for both syntax error and YYERROR.  |
	`-------------------------------------------------------------*/
yyerrlab1:
	yyerrstatus_ = 3;	/* Each real token shifted decrements this.  */

	for(;;) {
		yyn = yypact_[yystate];
		if(yyn != yypact_ninf_) {
			yyn += yyterror_;
			if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_) {
				yyn = yytable_[yyn];
				if (0 < yyn)
				break;
			}
		}

		/* Pop the current state because it cannot handle the error token.  */
		if(yystate_stack_.size() == 1)
			YYABORT;

		*yyerror_range[0] = *yysemantic_stack_[0];
		YY_SYMBOL_PRINT("Error: popping", yysemantic_stack_[0]);
		yypop_();
		yystate = yystate_stack_[0];
		YY_STACK_PRINT();
	}

	if (yyn == yyfinal_)
		goto yyacceptlab;

	*yyerror_range[1] = *yylval;
	// Using YYLLOC is tempting, but would change the location of
	// the look-ahead.  YYLOC is available though.
	yylloc_default(yyval, (yyerror_range - 1), 2);
	yysemantic_stack_.push (yylval);

	/* Shift the error token.  */
	YY_SYMBOL_PRINT ("Shifting", yysemantic_stack_[0]);

	yystate = yyn;
	goto yynewstate;

	/* Accept.  */
yyacceptlab:
	yyresult = 0;
	goto yyreturn;

	/* Abort.  */
yyabortlab:
	yyresult = 1;
	goto yyreturn;

yyreturn:
	if (yychar != yyeof_ && yychar != yyempty_)
		YY_SYMBOL_PRINT("Cleanup: discarding lookahead", yylval);

	/* Do not reclaim the symbols of the rule which action triggered
		this YYABORT or YYACCEPT.  */
	yypop_ (yylen);
	while (yystate_stack_.size() != 1) {
		YY_SYMBOL_PRINT("Cleanup: popping", yysemantic_stack_[0]);
		yypop_ ();
	}

	return yyresult;
}

// Generate an error message.
std::string
Parser::yysyntax_error_ (int yystate, int tok)
{
	std::string res;
	YYUSE (yystate);
#if YYERROR_VERBOSE
	int yyn = yypact_[yystate];
	if (yypact_ninf_ < yyn && yyn <= yylast_) {
	/* Start YYX at -YYN if negative to avoid negative indexes in
	   YYCHECK.  */
	int yyxbegin = yyn < 0 ? -yyn : 0;

	/* Stay within bounds of both yycheck and yytname.  */
	int yychecklim = yylast_ - yyn + 1;
	int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
	int count = 0;
	for (int x = yyxbegin; x < yyxend; ++x)
		if (yycheck_[x + yyn] == x && x != yyterror_)
			++count;

	// FIXME: This method of building the message is not compatible
	// with internationalization.  It should work like yacc.c does it.
	// That is, first build a string that looks like this:
	// "syntax error, unexpected %s or %s or %s"
	// Then, invoke YY_ on this string.
	// Finally, use the string as a format to output
	// yytname_[tok], etc.
	// Until this gets fixed, this message appears in English only.
	res = "syntax error, unexpected ";
	res += yytnamerr_ (yytname_[tok]);
	if (count < 5)
	  {
	    count = 0;
	    for (int x = yyxbegin; x < yyxend; ++x)
	      if (yycheck_[x + yyn] == x && x != yyterror_)
		{
		  res += (!count++) ? ", expecting " : " or ";
		  res += yytnamerr_ (yytname_[x]);
		}
	  }
      }
    else
#endif
      res = YY_("syntax error");
    return res;
  }


  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
  const signed char Parser::yypact_ninf_ = -56;
  const signed char
  Parser::yypact_[] =
  {
       -56,    19,   100,   -56,   -56,   -56,     0,     0,   -56,   -56,
     -56,   -56,   -56,   -56,    25,   -56,   -56,    30,    31,    -2,
     -56,     2,   -56,   -56,     4,    25,     0,   -56,   -56,    60,
     -56,   -56,   -56,   -56,   -56,     0,     5,     5,   -56,   -56,
       0,   -56,   -56,     0,   -56,    25,   -56,   -56,    25,    25,
      25,   -56,   -56,     6,   -56,     8,     1,   -56,   -56,     0,
      18,   -56,     5,     5,   -56,   -56,   -56,   -56,   -56,   -56,
     -56,   -56,     3,   -56,   -56,    48,   -56,   -56,   -18,    12,
     -56,   -56,   -56,   -56,     0,    50,     9,   -56,   -56,   -56,
      12,   -56,   -56,   -56
  };

  /* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
     doesn't specify something else to do.  Zero means the default is an
     error.  */
  const unsigned char
  Parser::yydefact_[] =
  {
         3,     0,     0,     1,    32,    30,     0,     0,    25,    35,
      36,    37,     7,    28,     0,    10,    11,     0,     0,     0,
      15,     0,    29,    17,     0,     0,     0,    20,    21,     0,
       6,     4,     5,    23,    22,     0,     0,     0,    65,    62,
      26,    38,    63,    27,    66,     8,    12,    13,     0,     0,
       0,    19,    24,     0,    51,     0,     0,    46,    48,    34,
      40,    44,    33,    31,    39,     9,    14,    16,    18,    50,
      56,    49,     0,    47,     2,    41,    42,    45,    52,    53,
      68,    43,    55,    56,     0,     0,     0,    64,    57,    58,
      54,    59,    60,    61
  };

  /* YYPGOTO[NTERM-NUM].  */
  const signed char
  Parser::yypgoto_[] =
  {
       -56,   -56,   -56,   -56,    54,   -56,   -56,   -56,   -56,   -56,
      -3,   -32,    20,   -56,     7,   -56,   -56,   -56,   -24,   -26,
     -56,   -55,    -9,   -56
  };

  /* YYDEFGOTO[NTERM-NUM].  */
  const signed char
  Parser::yydefgoto_[] =
  {
        -1,     1,     2,    31,    55,    33,    37,    36,    34,    35,
      40,    61,    62,    56,    57,    58,    70,    78,    79,    41,
      89,    42,    45,    74
  };

  /* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule which
     number is the opposite.  If zero, do what YYDEFACT says.  */
  const signed char Parser::yytable_ninf_ = -68;
  const signed char
  Parser::yytable_[] =
  {
        52,   -67,    53,    38,    43,    76,     4,     5,     6,     7,
       8,     9,    10,    11,    64,    38,    51,    64,    13,     3,
      81,    38,    75,    82,    83,    84,    85,    86,    44,    22,
      77,    77,    59,    64,    46,    47,    65,    26,    48,    66,
      67,    68,    49,    39,    50,    54,    72,    69,    60,    71,
      80,    38,    93,    88,    92,    39,    32,    63,    91,    90,
      87,    53,     0,    73,    88,     4,     5,     6,     7,     8,
       9,    10,    11,     0,     0,     0,     0,    13,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
       0,     0,     0,     0,    54,     4,     5,     6,     7,     8,
       9,    10,    11,     0,     0,     0,    12,    13,    14,    15,
      16,    17,    18,    19,    20,     0,     0,    21,    22,    23,
       0,    24,     0,     0,    25,     0,    26,     0,    27,     0,
       0,    28,     0,     0,     0,    29,    30
  };

  /* YYCHECK.  */
  const signed char
  Parser::yycheck_[] =
  {
        26,     0,     1,     3,     7,    60,     5,     6,     7,     8,
       9,    10,    11,    12,    40,     3,    25,    43,    17,     0,
      75,     3,     4,    41,    42,    13,    14,    15,     3,    28,
      62,    63,    35,    59,     4,     4,    45,    36,    40,    48,
      49,    50,    40,    43,    40,    44,    45,    41,    43,    41,
      47,     3,    43,    79,     4,    43,     2,    37,    84,    83,
      48,     1,    -1,    56,    90,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      -1,    31,    -1,    -1,    34,    -1,    36,    -1,    38,    -1,
      -1,    41,    -1,    -1,    -1,    45,    46
  };

  /* STOS_[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
  const unsigned char
  Parser::yystos_[] =
  {
         0,    50,    51,     0,     5,     6,     7,     8,     9,    10,
      11,    12,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    27,    28,    29,    31,    34,    36,    38,    41,    45,
      46,    52,    53,    54,    57,    58,    56,    55,     3,    43,
      59,    68,    70,    59,     3,    71,     4,     4,    40,    40,
      40,    71,    68,     1,    44,    53,    62,    63,    64,    59,
      43,    60,    61,    61,    68,    71,    71,    71,    71,    41,
      65,    41,    45,    63,    72,     4,    70,    60,    66,    67,
      47,    70,    41,    42,    13,    14,    15,    48,    68,    69,
      67,    68,     4,    43
  };

#if YYDEBUG
  /* TOKEN_NUMBER_[YYLEX-NUM] -- Internal symbol number corresponding
     to YYLEX-NUM.  */
  const unsigned short int
  Parser::yytoken_number_[] =
  {
         0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303
  };
#endif

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
  const unsigned char
  Parser::yyr1_[] =
  {
         0,    49,    50,    51,    51,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    53,    53,    53,    53,    53,    53,    53,    53,
      55,    54,    56,    54,    57,    58,    58,    58,    59,    59,
      60,    60,    60,    60,    61,    61,    62,    62,    63,    63,
      63,    65,    64,    66,    66,    66,    67,    67,    67,    67,
      67,    67,    68,    68,    69,    70,    71,    72,    72
  };

  /* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
  const unsigned char
  Parser::yyr2_[] =
  {
         0,     2,     4,     0,     2,     1,     1,     1,     2,     3,
       1,     1,     2,     2,     3,     1,     3,     1,     3,     2,
       1,     1,     1,     1,     2,     1,     2,     2,     1,     1,
       0,     3,     0,     3,     2,     1,     1,     1,     1,     2,
       1,     2,     2,     3,     1,     2,     1,     2,     1,     2,
       2,     0,     3,     1,     3,     2,     0,     2,     2,     3,
       3,     3,     1,     1,     1,     1,     1,     0,     2
  };

  /* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
     First, the terminals, then, starting at \a yyntokens_, nonterminals.  */
  const char*
  const Parser::yytname_[] =
  {
    "\"end of file\"", "error", "$undefined", "\"string\"", "\"integer\"",
  "\"%token\"", "\"%nterm\"", "\"%destructor {...}\"",
  "\"%printer {...}\"", "\"%union {...}\"", "\"%left\"", "\"%right\"",
  "\"%nonassoc\"", "\"%prec\"", "\"%dprec\"", "\"%merge\"", "\"%debug\"",
  "\"%default-prec\"", "\"%define\"", "\"%defines\"", "\"%error-verbose\"",
  "\"%expect\"", "\"%expect-rr\"", "\"%file-prefix\"",
  "\"%initial-action {...}\"", "\"%lex-param {...}\"", "\"%locations\"",
  "\"%name-prefix\"", "\"%no-default-prec\"", "\"%no-lines\"",
  "\"%nondeterministic-parser\"", "\"%output\"", "\"%parse-param {...}\"",
  "\"%pure-parser\"", "\"%require\"", "\"%skeleton\"", "\"%start\"",
  "\"%token-table\"", "\"%verbose\"", "\"%yacc\"", "\"=\"", "\";\"",
  "\"|\"", "\"identifier\"", "\"identifier:\"", "\"%%\"", "\"%{...%}\"",
  "\"epilogue\"", "\"{...}\"", "$accept", "input", "declarations",
  "declaration", "grammar_declaration", "symbol_declaration", "$@1", "$@2",
  "precedence_declaration", "precedence_declarator", "symbols.1",
  "symbol_def", "symbol_defs.1", "grammar", "rules_or_grammar_declaration",
  "rules", "@3", "rhses.1", "rhs", "symbol", "action", "string_as_id",
  "string_content", "epilogue.opt", 0
  };

  /* YYRHS -- A `-1'-separated list of the rules' RHS.  */
  const Parser::rhs_number_type
  Parser::yyrhs_[] =
  {
        50,     0,    -1,    51,    45,    62,    72,    -1,    -1,    51,
      52,    -1,    53,    -1,    46,    -1,    16,    -1,    18,    71,
      -1,    18,    71,    71,    -1,    19,    -1,    20,    -1,    21,
       4,    -1,    22,     4,    -1,    23,    40,    71,    -1,    24,
      -1,    27,    40,    71,    -1,    29,    -1,    31,    40,    71,
      -1,    34,    71,    -1,    38,    -1,    41,    -1,    57,    -1,
      54,    -1,    36,    68,    -1,     9,    -1,     7,    59,    -1,
       8,    59,    -1,    17,    -1,    28,    -1,    -1,     6,    55,
      61,    -1,    -1,     5,    56,    61,    -1,    58,    59,    -1,
      10,    -1,    11,    -1,    12,    -1,    68,    -1,    59,    68,
      -1,    43,    -1,    43,     4,    -1,    43,    70,    -1,    43,
       4,    70,    -1,    60,    -1,    61,    60,    -1,    63,    -1,
      62,    63,    -1,    64,    -1,    53,    41,    -1,     1,    41,
      -1,    -1,    44,    65,    66,    -1,    67,    -1,    66,    42,
      67,    -1,    66,    41,    -1,    -1,    67,    68,    -1,    67,
      69,    -1,    67,    13,    68,    -1,    67,    14,     4,    -1,
      67,    15,    43,    -1,    43,    -1,    70,    -1,    48,    -1,
       3,    -1,     3,    -1,    -1,    45,    47,    -1
  };

  /* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
     YYRHS.  */
  const unsigned char
  Parser::yyprhs_[] =
  {
         0,     0,     3,     8,     9,    12,    14,    16,    18,    21,
      25,    27,    29,    32,    35,    39,    41,    45,    47,    51,
      54,    56,    58,    60,    62,    65,    67,    70,    73,    75,
      77,    78,    82,    83,    87,    90,    92,    94,    96,    98,
     101,   103,   106,   109,   113,   115,   118,   120,   123,   125,
     128,   131,   132,   136,   138,   142,   145,   146,   149,   152,
     156,   160,   164,   166,   168,   170,   172,   174,   175
  };

  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
  const unsigned short int
  Parser::yyrline_[] =
  {
         0,    90,    90,   100,   102,   106,   107,   119,   120,   125,
     133,   134,   135,   136,   137,   138,   142,   143,   144,   145,
     146,   147,   151,   152,   153,   157,   161,   165,   169,   173,
     180,   180,   184,   184,   190,   229,   230,   231,   236,   237,
     254,   261,   269,   277,   291,   292,   301,   302,   308,   309,
     310,   316,   316,   324,   325,   326,   331,   332,   334,   336,
     338,   340,   345,   346,   350,   355,   363,   368,   370
  };

  // Print the state stack on the debug stream.
  void
  Parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (state_stack_type::const_iterator i = yystate_stack_.begin ();
	 i != yystate_stack_.end (); ++i)
      *yycdebug_ << ' ' << *i;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  Parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    /* Print the symbols being reduced, and their result.  */
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
	       << " (line " << yylno << "), \n";
    /* The symbols being reduced.  */
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT("   $" << yyi + 1 << " =",
		       (yysemantic_stack_[(yynrhs) - (yyi + 1)]));
  }

  /* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
  Parser::token_number_type
  Parser::yytranslate_ (int t) const
  {
    static
    const token_number_type
    translate_table[] =
    {
           0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
    };
    if ((unsigned int) t <= yyuser_token_number_max_)
      return translate_table[t];
    else
      return yyundef_token_;
  }

  const int Parser::yyeof_ = 0;
  const int Parser::yylast_ = 146;
  const int Parser::yynnts_ = 24;
  const int Parser::yyempty_ = -2;
  const int Parser::yyfinal_ = 3;
  const int Parser::yyterror_ = 1;
  const int Parser::yyerrcode_ = 256;
  const int Parser::yyntokens_ = 49;

  const unsigned int Parser::yyuser_token_number_max_ = 303;
  const Parser::token_number_type Parser::yyundef_token_ = 2;

} // namespace impl
} // namespace bisonx
} // namespace v3c



/* Line 81 of bison-parse.m4  */
#line 376 "../../../v3c/parse/bisonx_parser.ypp"


